-- FILE: \TRCClawCrane.lua

-- For Animating the Claw Dropping and detection with Vars
LevelVars.ClawMovementDisable1 = false
LevelVars.ClawMovementDisable2 = false
LevelVars.ClawMovementDisable3 = false
LevelVars.ClawMovementEnable = false
LevelVars.ClawMovementDelayedFloor = false
LevelVars.ClawSnapshotOnLevelLoad = false -- Required to Determine the Origin of the Claw for resetting back when lara leaves the room/s

-- Snapshotting Positions for falling and reeling back in
LevelVars.LaraPosYSnapshot = 0

-- Distance Calcluation for Y position to alter drop and raise times depending on Y pos she's standing
LevelVars.DistanceFromLaraY = 0

-- Claw Origin to help movement when lara Exits the box volume/room number
LevelVars.ClawOriginX = 0
LevelVars.ClawOriginY = 0
LevelVars.ClawOriginZ = 0

-- Primitive Timer system for delays
LevelVars.ClawIdleTimer = 3

function TRCClawCrane()

-- You must name the items in the editor by the names in this script, 
local CraneBase = Objects.GetMoveableByName("crane_base")
local CraneClaw = Objects.GetMoveableByName("crane_claw")
local CraneChain = Objects.GetMoveableByName("crane_chain")

-- Positional and Room Data
local LaraPos = Lara:GetPosition()
local LaraRoom = Lara:GetRoomNumber() -- If you wanna assign room numbers/tags for the crane, can be swapped out for being inside a box volume
local CraneBasePos = CraneBase:GetPosition()
local CraneClawPos = CraneClaw:GetPosition()
local CraneChainPos = CraneChain:GetPosition()
local BoxVol = Objects.GetVolumeByName("crane_box_trigger") -- Allows Box Volume Detection for Crane, make sure to add box volume and rename it to this in the editor
local LaraInBox = BoxVol:IsMoveableInside(Lara)

	-- Snapshotting Origins when level starts(Acts like OnStart but retains values)
	if not LevelVars.ClawSnapshotOnLevelLoad then
		LevelFuncs.Engine.Node.ModifyLevelVariable("ClawOriginX", 4, CraneClawPos.x)
		LevelFuncs.Engine.Node.ModifyLevelVariable("ClawOriginY", 4, CraneClawPos.y)
		LevelFuncs.Engine.Node.ModifyLevelVariable("ClawOriginZ", 4, CraneClawPos.z)
		LevelVars.ClawSnapshotOnLevelLoad = true
	end

-- Distance Calculations to help with crane movement, crash timing and to return the crane back to where it started
local ComparisonLaraCrane = CalculateHorizontalDistance(LaraPos, CraneClawPos)
local ComparisonLaraCraneY = CalculateDistance(LaraPos, CraneClawPos)
local ComparisonCraneOrigin = CalculateHorizontalDistance(Vec3(LevelVars.ClawOriginX, LevelVars.ClawOriginY, LevelVars.ClawOriginZ), CraneClawPos)

-- Vars which constantly need to be recalculated for drop and raise
LevelVars.DistanceFromLara = ComparisonLaraCrane / 1024
LevelVars.DistanceFromOrigin = ComparisonCraneOrigin / 1024

-- Location position after all calculations have been done
local SetCranePosBase = Vec3(LaraPos.x, CraneBasePos.y, LaraPos.z)
local SetCranePosClaw = Vec3(LaraPos.x, CraneClawPos.y, LaraPos.z)
local SetCranePosChain = Vec3(LaraPos.x, CraneChainPos.y, LaraPos.z)

-- Random Math for impact sprites
local RandomXZ = math.random(10, 20)
local RandomY = math.random(22, 25)

-- Math for 3D created bounding box(crazy eh?)
local test1 = CraneClawPos.x + 448
local test2 = CraneClawPos.x - 448
local test3 = CraneClawPos.y + 64
local test4 = CraneClawPos.y - 1024
local test5 = CraneClawPos.z + 448
local test6 = CraneClawPos.z - 448

	-- To hurt Lara when origin of Crane Claw is within laras Position
	if LaraPos.x >= test2 and LaraPos.x <= test1 and LaraPos.y <= test3 and LaraPos.y >= test4 and LaraPos.z <= test5 and LaraPos.z >= test6 then
		Lara:SetHP(Lara:GetHP() - 100)
	end
	
	-- To determine if lara is in a box volume/roomnumber to start the movement of the crane or to send it back to Point Origin
	-- Replace "LaraInBox" with "LaraRoom == 6" if you want Room Detection or vice versa
	if LaraInBox and Lara:GetHP() > 1 and not LevelVars.ClawMovementEnable then
		LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_base", SetCranePosBase, false, LevelVars.DistanceFromLara, false)
		LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_claw", SetCranePosClaw, false, LevelVars.DistanceFromLara, false)
		LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_chain", SetCranePosChain, false, LevelVars.DistanceFromLara, false)
		Sound.PlaySound(1045, SetCranePosClaw)
	elseif not LevelVars.ClawMovementEnable and Lara:GetHP() > 1 then
		LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_base", Vec3(LevelVars.ClawOriginX, CraneBasePos.y, LevelVars.ClawOriginZ), false, LevelVars.DistanceFromOrigin, false)
		LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_claw", Vec3(LevelVars.ClawOriginX, CraneClawPos.y, LevelVars.ClawOriginZ), false, LevelVars.DistanceFromOrigin, false)
		LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_claw", Vec3(LevelVars.ClawOriginX, CraneChainPos.y, LevelVars.ClawOriginZ), false, LevelVars.DistanceFromOrigin, false)
		if LevelVars.DistanceFromOrigin > 0 then
			Sound.PlaySound(1045, SetCranePosClaw)
		end
		if LevelVars.DistanceFromOrigin == 0 then
			Sound.StopSound(1045)
		end
	end
	
	-- If it's in Laras X and Z position to initiate the crashdown
	if CraneClawPos.x == LaraPos.x and CraneClawPos.z == LaraPos.z and not LevelVars.ClawMovementDisable3 then
		LevelFuncs.Engine.Node.ModifyLevelVariable("LaraPosYSnapshot", 4, LaraPos.y)
		LevelFuncs.Engine.Node.ModifyLevelVariable("DistanceFromLaraY", 4, ComparisonLaraCraneY)
		LevelFuncs.Engine.Node.ModifyLevelVariable("DistanceFromLaraY", 3, 4096)
		Sound.StopSound(1045)
		Sound.PlaySound(1046, SetCranePosClaw)
		LevelVars.ClawMovementDisable3 = true
		LevelVars.ClawMovementDisable1 = true
		LevelVars.ClawMovementEnable = true
	end
	
	-- Delay before Crashing down to the snapshotted Laras Point of Origin on the Y Axis
	if LevelVars.ClawMovementDisable1 then
		LevelFuncs.Engine.Node.ModifyLevelVariable("ClawIdleTimer", 1, 0.1)
		if LevelVars.ClawIdleTimer >= 0.09 and LevelVars.ClawIdleTimer <= 0.11 then
			LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_claw", TEN.Vec3(CraneClawPos.x, LevelVars.LaraPosYSnapshot, CraneClawPos.z), false, LevelVars.DistanceFromLaraY, false) -- 0.5
			LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_chain", TEN.Vec3(CraneClawPos.x, LevelVars.LaraPosYSnapshot - 1024, CraneClawPos.z), false, LevelVars.DistanceFromLaraY, false)
			CraneClaw:SetAnim(1)
			Sound.PlaySound(1042, SetCranePosClaw)
		end
		if LevelVars.ClawIdleTimer <= 0 then
			LevelFuncs.Engine.Node.ModifyLevelVariable("ClawIdleTimer", 4, 0)
			if CraneClawPos.y == LevelVars.LaraPosYSnapshot then
				Sound.PlaySound(1043, SetCranePosClaw)
				CraneClaw:SetAnim(2)
				LevelFuncs.Engine.Node.ShakeCamera(-LevelVars.DistanceFromLara + 96)
				TEN.Effects.EmitParticle(Vec3(CraneClawPos.x, CraneClawPos.y, CraneClawPos.z), Vec3(RandomXZ, -RandomY, RandomXZ), 2, 13.5, 0, Color(225,225,225,255), Color(255,255,255,255), 9, 200, 0, 0.75, 0, 0)
				TEN.Effects.EmitParticle(Vec3(CraneClawPos.x, CraneClawPos.y, CraneClawPos.z), Vec3(-RandomXZ, -RandomY, -RandomXZ), 2, 13.5, 0, Color(200,200,200,255), Color(255,255,255,255), 9, 200, 0, 0.75, 0, 0)
				TEN.Effects.EmitParticle(Vec3(CraneClawPos.x, CraneClawPos.y, CraneClawPos.z), Vec3(RandomXZ, -RandomY, RandomXZ), 2, 13.5, 0, Color(175,175,175,255), Color(255,255,255,255), 9, 200, 0, 0.75, 0, 0)
				TEN.Effects.EmitParticle(Vec3(CraneClawPos.x, CraneClawPos.y, CraneClawPos.z), Vec3(-RandomXZ, -RandomY, -RandomXZ), 2, 13.5, 0, Color(200,200,200,255), Color(255,255,255,255), 9, 200, 0, 0.75, 0, 0)
				TEN.Effects.EmitParticle(Vec3(CraneClawPos.x, CraneClawPos.y, CraneClawPos.z), Vec3(-RandomXZ, -RandomY, RandomXZ), 2, 13.5, 0, Color(175,175,175,255), Color(255,255,255,255), 9, 200, 0, 0.75, 0, 0)
				LevelVars.ClawIdleTimer = 2
				LevelVars.ClawMovementDisable2 = true
				LevelVars.ClawMovementDisable1 = false
				LevelVars.ClawMovementDelayedFloor = true
			end
		end
	end
	
	-- Delay on floor with primitive timer
	if LevelVars.ClawMovementDelayedFloor then
		LevelFuncs.Engine.Node.ModifyLevelVariable("ClawIdleTimer", 1, 0.1)
		if LevelVars.ClawIdleTimer <= 0 then
			LevelVars.ClawIdleTimer = 2
			LevelVars.ClawMovementDisable2 = true
			LevelVars.ClawMovementDelayedFloor = false
		end
	end
	
	-- Delay before reeling back in to the point of origin on the Y Axis
	if LevelVars.ClawMovementDisable2 then
		LevelFuncs.Engine.Node.ModifyLevelVariable("ClawIdleTimer", 1, 0.1)
		if LevelVars.ClawIdleTimer >= 0.09 and LevelVars.ClawIdleTimer <= 0.11 then
			LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_claw", TEN.Vec3(CraneClawPos.x, LevelVars.ClawOriginY, CraneClawPos.z), false, LevelVars.DistanceFromLaraY * 2, false)
			LevelFuncs.Engine.Node.ChangeMoveablePositionOverTimespan("crane_chain", TEN.Vec3(CraneClawPos.x, LevelVars.ClawOriginY - 1024, CraneClawPos.z), false, LevelVars.DistanceFromLaraY * 2, false)
		end
		if LevelVars.ClawIdleTimer <= 0 then
			LevelFuncs.Engine.Node.ModifyLevelVariable("ClawIdleTimer", 4, 0)
			Sound.PlaySound(1048, SetCranePosClaw)
			if CraneClawPos.y == LevelVars.ClawOriginY then
				LevelVars.ClawMovementDisable3 = false
				LevelVars.ClawMovementEnable = false
				LevelVars.ClawIdleTimer = 3
				LevelVars.ClawMovementDisable2 = false
			end
		end
	end
	
	-- DEVTEST: Stats for Nerds
	--LevelFuncs.Engine.Node.DrawText("Crane Y Snapshot: " .. LevelVars.ClawOriginY .. "\nLara Y Snapshot: " .. LevelVars.LaraPosYSnapshot .. "\nClaw Distance from Lara Hoz: " .. LevelVars.DistanceFromLara .. "\nClaw Distance from Lara Vert: " .. LevelVars.DistanceFromLaraY .. "\nClaw Distance from Origin: " .. LevelVars.DistanceFromOrigin, 50, 75, 1, 1, TEN.Color(255,255,255), 0.75)

end